import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load_module, reload_module, get_stdout, check_source
from functools import reduce
import os

exercise = 'src.range_of_list'

def f(list):
    return '['+', '.join([str(i) for i in list])+']'

@points('1.range_of_list')
class RangeOfListTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=["2"] * 10):
           cls.module = load_module(exercise, 'en')

    def test_0_main_program_ok(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test_1_function_exists(self):
        try:
            from src.range_of_list import range_of_list
            list = [1, 2, 3]
            range_of_list(list)
        except:
            self.assertTrue(False, f'Din kod bör innehålla en funktion som heter range_of_list(list: list)')
        try:
            from src.range_of_list import range_of_list
            list = [1, 2, 3]
            range_of_list(list)
        except:
            self.assertTrue(False, f'Se till att den funktionen kan kallas enligt följande:\nrange_of_list([1, 2, 3])')

    def test_2_functionality_ok(self):
        for list in [[1,2,3], [1,3,67,7,4,23,1,5,7,4], [1], [33,4,4,5,7,43,32,1,3,6,7,7,4], [1,1,1,1,1,1,1], [0,0,1,2,3,4,5,6,7,8], [-100, 10000, 2012, 123, -123, 3123, 323], [-123,123,43,2345,54564,1234,52,6242] ]:
            with patch('builtins.input', side_effect=["2"] * 10):
                reload_module(self.module)
                output_at_start = get_stdout()
                from src.range_of_list import range_of_list
                res = range_of_list(list)
                output_all = get_stdout().replace(output_at_start, '', 1)
                expected = max(list)-min(list)

                self.assertFalse(res == None, f'Att anropa range_of_list({f(list)}) bör returnera {expected} nu returnerar det ingenting. Se till att du använder returkommandot i alla fall i din funktion!')
                self.assertEqual(res, expected, f'Att anropa range_of_list({f(list)}) bör returnera {expected} nu returnerar det {res}')
                self.assertFalse(len(output_all)>0, f'Att anropa range_of_list({f(list)}) ska inte skriva ut någonting, men det skrivs ut\n{output_all}\nta bort utskriftskommandon i funktionen')

if __name__ == '__main__':
    unittest.main()